/***************************************************************************

  CFont.h

  (c) 2000-2003 Benot Minisini <gambas@users.sourceforge.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __CFONT_H
#define __CFONT_H

#include <qfont.h>

#include "gambas.h"
#include "main.h"

#ifndef __CFONT_CPP
extern GB_DESC CFontDesc[];
extern void *CLASS_Font;

#else

#define THIS OBJECT(CFONT)

#endif

typedef
  struct {
    void *klass;
    QFont *font;
    enum { Name, Size, Bold, Italic, Underline, StrikeOut };
    }
  CFONT;

#define CFONT_WIDGET ((QFont *)0)
#define CFONT_SCREEN ((QFont *)1)
#define CFONT_DEVICE ((QFont *)2)

#define CFONT_is_widget(_object) (((CFONT *)_object)->font == CFONT_WIDGET)
#define CFONT_is_screen(_object) (((CFONT *)_object)->font == CFONT_SCREEN)
#define CFONT_is_device(_object) (((CFONT *)_object)->font == CFONT_DEVICE)

#define CFONT_TO_CWIDGET(_cfont) ((CWIDGET *)((char *)_cfont - offsetof(CWIDGET, font)))

QFont CFONT_get_font(CFONT *font);

#endif
